// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/customers.proto

package customers

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "github.com/micro/micro/v3/service/api"
	client "github.com/micro/micro/v3/service/client"
	server "github.com/micro/micro/v3/service/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for Customers service

func NewCustomersEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for Customers service

type CustomersService interface {
	// Creates a new, unverified customer
	Create(ctx context.Context, in *CreateRequest, opts ...client.CallOption) (*CreateResponse, error)
	// Mark the customer as verified
	MarkVerified(ctx context.Context, in *MarkVerifiedRequest, opts ...client.CallOption) (*MarkVerifiedResponse, error)
	// Retrieve a customer
	Read(ctx context.Context, in *ReadRequest, opts ...client.CallOption) (*ReadResponse, error)
	// Marks a customer as inactive
	Delete(ctx context.Context, in *DeleteRequest, opts ...client.CallOption) (*DeleteResponse, error)
	// Lists all customers
	List(ctx context.Context, in *ListRequest, opts ...client.CallOption) (*ListResponse, error)
	// Updates a customer
	Update(ctx context.Context, in *UpdateRequest, opts ...client.CallOption) (*UpdateResponse, error)
	// Ban the customer
	Ban(ctx context.Context, in *BanRequest, opts ...client.CallOption) (*BanResponse, error)
	// Unban the customer
	Unban(ctx context.Context, in *UnbanRequest, opts ...client.CallOption) (*UnbanResponse, error)
	// Login returns an auth token
	Login(ctx context.Context, in *LoginRequest, opts ...client.CallOption) (*LoginResponse, error)
	// Logout logs the user out
	Logout(ctx context.Context, in *LogoutRequest, opts ...client.CallOption) (*LogoutResponse, error)
	// Update the name
	UpdateName(ctx context.Context, in *UpdateNameRequest, opts ...client.CallOption) (*UpdateNameResponse, error)
}

type customersService struct {
	c    client.Client
	name string
}

func NewCustomersService(name string, c client.Client) CustomersService {
	return &customersService{
		c:    c,
		name: name,
	}
}

func (c *customersService) Create(ctx context.Context, in *CreateRequest, opts ...client.CallOption) (*CreateResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Create", in)
	out := new(CreateResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) MarkVerified(ctx context.Context, in *MarkVerifiedRequest, opts ...client.CallOption) (*MarkVerifiedResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.MarkVerified", in)
	out := new(MarkVerifiedResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) Read(ctx context.Context, in *ReadRequest, opts ...client.CallOption) (*ReadResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Read", in)
	out := new(ReadResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) Delete(ctx context.Context, in *DeleteRequest, opts ...client.CallOption) (*DeleteResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Delete", in)
	out := new(DeleteResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) List(ctx context.Context, in *ListRequest, opts ...client.CallOption) (*ListResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.List", in)
	out := new(ListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) Update(ctx context.Context, in *UpdateRequest, opts ...client.CallOption) (*UpdateResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Update", in)
	out := new(UpdateResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) Ban(ctx context.Context, in *BanRequest, opts ...client.CallOption) (*BanResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Ban", in)
	out := new(BanResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) Unban(ctx context.Context, in *UnbanRequest, opts ...client.CallOption) (*UnbanResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Unban", in)
	out := new(UnbanResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) Login(ctx context.Context, in *LoginRequest, opts ...client.CallOption) (*LoginResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Login", in)
	out := new(LoginResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) Logout(ctx context.Context, in *LogoutRequest, opts ...client.CallOption) (*LogoutResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.Logout", in)
	out := new(LogoutResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *customersService) UpdateName(ctx context.Context, in *UpdateNameRequest, opts ...client.CallOption) (*UpdateNameResponse, error) {
	req := c.c.NewRequest(c.name, "Customers.UpdateName", in)
	out := new(UpdateNameResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Customers service

type CustomersHandler interface {
	// Creates a new, unverified customer
	Create(context.Context, *CreateRequest, *CreateResponse) error
	// Mark the customer as verified
	MarkVerified(context.Context, *MarkVerifiedRequest, *MarkVerifiedResponse) error
	// Retrieve a customer
	Read(context.Context, *ReadRequest, *ReadResponse) error
	// Marks a customer as inactive
	Delete(context.Context, *DeleteRequest, *DeleteResponse) error
	// Lists all customers
	List(context.Context, *ListRequest, *ListResponse) error
	// Updates a customer
	Update(context.Context, *UpdateRequest, *UpdateResponse) error
	// Ban the customer
	Ban(context.Context, *BanRequest, *BanResponse) error
	// Unban the customer
	Unban(context.Context, *UnbanRequest, *UnbanResponse) error
	// Login returns an auth token
	Login(context.Context, *LoginRequest, *LoginResponse) error
	// Logout logs the user out
	Logout(context.Context, *LogoutRequest, *LogoutResponse) error
	// Update the name
	UpdateName(context.Context, *UpdateNameRequest, *UpdateNameResponse) error
}

func RegisterCustomersHandler(s server.Server, hdlr CustomersHandler, opts ...server.HandlerOption) error {
	type customers interface {
		Create(ctx context.Context, in *CreateRequest, out *CreateResponse) error
		MarkVerified(ctx context.Context, in *MarkVerifiedRequest, out *MarkVerifiedResponse) error
		Read(ctx context.Context, in *ReadRequest, out *ReadResponse) error
		Delete(ctx context.Context, in *DeleteRequest, out *DeleteResponse) error
		List(ctx context.Context, in *ListRequest, out *ListResponse) error
		Update(ctx context.Context, in *UpdateRequest, out *UpdateResponse) error
		Ban(ctx context.Context, in *BanRequest, out *BanResponse) error
		Unban(ctx context.Context, in *UnbanRequest, out *UnbanResponse) error
		Login(ctx context.Context, in *LoginRequest, out *LoginResponse) error
		Logout(ctx context.Context, in *LogoutRequest, out *LogoutResponse) error
		UpdateName(ctx context.Context, in *UpdateNameRequest, out *UpdateNameResponse) error
	}
	type Customers struct {
		customers
	}
	h := &customersHandler{hdlr}
	return s.Handle(s.NewHandler(&Customers{h}, opts...))
}

type customersHandler struct {
	CustomersHandler
}

func (h *customersHandler) Create(ctx context.Context, in *CreateRequest, out *CreateResponse) error {
	return h.CustomersHandler.Create(ctx, in, out)
}

func (h *customersHandler) MarkVerified(ctx context.Context, in *MarkVerifiedRequest, out *MarkVerifiedResponse) error {
	return h.CustomersHandler.MarkVerified(ctx, in, out)
}

func (h *customersHandler) Read(ctx context.Context, in *ReadRequest, out *ReadResponse) error {
	return h.CustomersHandler.Read(ctx, in, out)
}

func (h *customersHandler) Delete(ctx context.Context, in *DeleteRequest, out *DeleteResponse) error {
	return h.CustomersHandler.Delete(ctx, in, out)
}

func (h *customersHandler) List(ctx context.Context, in *ListRequest, out *ListResponse) error {
	return h.CustomersHandler.List(ctx, in, out)
}

func (h *customersHandler) Update(ctx context.Context, in *UpdateRequest, out *UpdateResponse) error {
	return h.CustomersHandler.Update(ctx, in, out)
}

func (h *customersHandler) Ban(ctx context.Context, in *BanRequest, out *BanResponse) error {
	return h.CustomersHandler.Ban(ctx, in, out)
}

func (h *customersHandler) Unban(ctx context.Context, in *UnbanRequest, out *UnbanResponse) error {
	return h.CustomersHandler.Unban(ctx, in, out)
}

func (h *customersHandler) Login(ctx context.Context, in *LoginRequest, out *LoginResponse) error {
	return h.CustomersHandler.Login(ctx, in, out)
}

func (h *customersHandler) Logout(ctx context.Context, in *LogoutRequest, out *LogoutResponse) error {
	return h.CustomersHandler.Logout(ctx, in, out)
}

func (h *customersHandler) UpdateName(ctx context.Context, in *UpdateNameRequest, out *UpdateNameResponse) error {
	return h.CustomersHandler.UpdateName(ctx, in, out)
}
