// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/ethereum.proto

package ethereum

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "github.com/micro/micro/v3/service/api"
	client "github.com/micro/micro/v3/service/client"
	server "github.com/micro/micro/v3/service/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for Ethereum service

func NewEthereumEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for Ethereum service

type EthereumService interface {
	Balance(ctx context.Context, in *BalanceRequest, opts ...client.CallOption) (*BalanceResponse, error)
	Broadcast(ctx context.Context, in *BroadcastRequest, opts ...client.CallOption) (*BroadcastResponse, error)
	Transaction(ctx context.Context, in *TransactionRequest, opts ...client.CallOption) (*TransactionResponse, error)
}

type ethereumService struct {
	c    client.Client
	name string
}

func NewEthereumService(name string, c client.Client) EthereumService {
	return &ethereumService{
		c:    c,
		name: name,
	}
}

func (c *ethereumService) Balance(ctx context.Context, in *BalanceRequest, opts ...client.CallOption) (*BalanceResponse, error) {
	req := c.c.NewRequest(c.name, "Ethereum.Balance", in)
	out := new(BalanceResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ethereumService) Broadcast(ctx context.Context, in *BroadcastRequest, opts ...client.CallOption) (*BroadcastResponse, error) {
	req := c.c.NewRequest(c.name, "Ethereum.Broadcast", in)
	out := new(BroadcastResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ethereumService) Transaction(ctx context.Context, in *TransactionRequest, opts ...client.CallOption) (*TransactionResponse, error) {
	req := c.c.NewRequest(c.name, "Ethereum.Transaction", in)
	out := new(TransactionResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Ethereum service

type EthereumHandler interface {
	Balance(context.Context, *BalanceRequest, *BalanceResponse) error
	Broadcast(context.Context, *BroadcastRequest, *BroadcastResponse) error
	Transaction(context.Context, *TransactionRequest, *TransactionResponse) error
}

func RegisterEthereumHandler(s server.Server, hdlr EthereumHandler, opts ...server.HandlerOption) error {
	type ethereum interface {
		Balance(ctx context.Context, in *BalanceRequest, out *BalanceResponse) error
		Broadcast(ctx context.Context, in *BroadcastRequest, out *BroadcastResponse) error
		Transaction(ctx context.Context, in *TransactionRequest, out *TransactionResponse) error
	}
	type Ethereum struct {
		ethereum
	}
	h := &ethereumHandler{hdlr}
	return s.Handle(s.NewHandler(&Ethereum{h}, opts...))
}

type ethereumHandler struct {
	EthereumHandler
}

func (h *ethereumHandler) Balance(ctx context.Context, in *BalanceRequest, out *BalanceResponse) error {
	return h.EthereumHandler.Balance(ctx, in, out)
}

func (h *ethereumHandler) Broadcast(ctx context.Context, in *BroadcastRequest, out *BroadcastResponse) error {
	return h.EthereumHandler.Broadcast(ctx, in, out)
}

func (h *ethereumHandler) Transaction(ctx context.Context, in *TransactionRequest, out *TransactionResponse) error {
	return h.EthereumHandler.Transaction(ctx, in, out)
}
